/ define a function for each of the various
/ basic types which returns the minimum or
/ maximum value.
ifndef MINMAX_H
 define MINMAX_H

verload max;
verload min;

define defminmax(typex)		    \
   inline typex &max(typex &a, typex &b)   \
   { if (a > b) return a; else return b; } \
				    \
   inline typex &min(typex &a, typex &b)   \
   { if (a < b) return a; else return b; }

/ all basic types
efminmax(char)
efminmax(short)
efminmax(int)
efminmax(long)

efminmax(unsigned char)
efminmax(unsigned short)
efminmax(unsigned int)
efminmax(unsigned long)

efminmax(float)
efminmax(double)

/ pointers to each basic type
efminmax(char *)
efminmax(short *)
efminmax(int *)
efminmax(long *)

efminmax(unsigned char *)
efminmax(unsigned short *)
efminmax(unsigned int *)
efminmax(unsigned long *)

efminmax(float *)
efminmax(double *)
endif /* MINMAX_H */
